#!/usr/bin/ruby

indir = "/lib/modules/"

kversion = ARGV[0]
if kversion.nil?
	$stderr.puts "Usage: modextract.rb kernelversion"
	exit 1 
end

system("mkdir " + indir + kversion + "/modules.pcidir")
File.open(indir + kversion + "/modules.pcimap").each { |line|
	toks = line.strip.split
	unless toks[0] =~ /#/
		modname = toks[0]
		vendor = toks[1][-4..-1]
		device = toks[2][-4..-1]
		outfile = File.new(indir + kversion + "/modules.pcidir/" +  vendor.to_s + "_" + device.to_s, "a")
		$stderr.puts vendor.to_s + " " + device.to_s
		outfile.write(modname + "\n")
		outfile.close
	end
}

system("mkdir " + indir + kversion + "/modules.usbdir")
File.open(indir + kversion + "/modules.usbmap").each { |line|
	toks = line.strip.split
	unless toks[0] =~ /#/
		modname = toks[0]
		vendor = toks[2][-4..-1]
		device = toks[3][-4..-1]
		outfile = File.new(indir + kversion + "/modules.usbdir/" +  vendor.to_s + "_" + device.to_s, "a")
		$stderr.puts vendor.to_s + " " + device.to_s
		outfile.write(modname + "\n")
		outfile.close
	end
}
